/*
    tstore - an archive format for archiving tar archives
    Copyright (C) 2005  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "tstore.h"
#include "test.h"

int main(int argc, char ** argv)
{
  uint8_t newheader[512];
  struct timeval now;
  int fd;

  if (argc != 2) {
    fprintf(stderr,"Uage: %s <store>\n",argv[0]);
    return 1;
  }

  if (gettimeofday(&now,NULL)) errstop("gettimeofday");

  memset(newheader,0,512);

  PUT_BNUM(newheader+NEXTPTR_OFFSET,0);
  PUT_BNUM(newheader+STORESIZE_OFFSET,1);
  PUT_NTIM(newheader+NANOSEC_OFFSET,now.tv_usec*1000);
  PUT_TIME(newheader+SECONDS_OFFSET,now.tv_sec);
  PUT_SIZE(newheader+FILESIZE_OFFSET,0);
  newheader[DIRTYFLAG_OFFSET]=0;

  strcpy(newheader+MAGIC_STRING_OFFSET,"TSTORE6");

  fd=open(argv[1],O_WRONLY|O_CREAT|O_EXCL,0666);
  if (fd==-1) errstop(argv[1]);
  if(write(fd,newheader,512)!=512) errstop(argv[1]);
  close(fd);

  return 0;
}
