/*
    tstore - an archive format for archiving tar archives
    Copyright (C) 2004,2005  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _TSDEFS_H
#define _TSDEFS_H

#define PUT_BNUM(_p,_v) put_nbyteint(_p,5,_v)
#define GET_BNUM(_p)    get_nbyteint(_p,5)
#define PUT_TIME(_p,_v) put_nbyteint(_p,5,_v)
#define GET_TIME(_p)    get_nbyteint(_p,5)
#define PUT_NTIM(_p,_v) put_nbyteint(_p,4,_v)
#define GET_NTIM(_p)    get_nbyteint(_p,4)
#define PUT_SIZE(_p,_v) put_nbyteint(_p,7,_v)
#define GET_SIZE(_p)    get_nbyteint(_p,7)

/* some random number */
#define TSTORE_MAGIC	0x74617273

/* various sizes */
#define TS_BLOCK_SIZE 512
#define FANOUT 102

/* Header block offsets */

#define MAGIC_STRING_OFFSET 0
#define FILENAME_OFFSET 0

#define NEXTPTR_OFFSET   (TS_BLOCK_SIZE    - 5)
#define STORESIZE_OFFSET (NEXTPTR_OFFSET   - 5)
#define TREEPTR_OFFSET   (STORESIZE_OFFSET - 5)
#define FILESIZE_OFFSET  (TREEPTR_OFFSET   - 7)
#define NANOSEC_OFFSET   (FILESIZE_OFFSET  - 4)
#define SECONDS_OFFSET   (NANOSEC_OFFSET   - 5)
#define DIRTYFLAG_OFFSET (TREEPTR_OFFSET   + 4)
#define TS_MAX_NAME_LEN  (SECONDS_OFFSET   - 1)

#endif
